/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.18 by edhill, Tue Oct 21 20:42:16 2003 UTC revision 1.116 by edhill, Thu Jan 6 15:32:16 2005 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          printf "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 62  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    .SUFFIXES:
128    .SUFFIXES: .$tfs .F
129    .F.$tfs:
130            $LN \$< \$@
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
243      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
244      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
245      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246        tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248        tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
253            
254      echo "test" > test      echo "test" > test
255      ln -s ./test link      ln -s ./test link
# Line 103  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # look for possible fortran compilers      look_for_makedepend
271      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"  
272        #================================================================
273        #  look for possible C compilers
274        tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275        p_CC=
276        for c in $tmp ; do
277            rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309        fi
310    
311        #================================================================
312        #  look for possible FORTRAN compilers
313        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
316          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 121  EOF Line 327  EOF
327              p_FC="$p_FC $c"              p_FC="$p_FC $c"
328          fi          fi
329      done      done
330        rm -f ./hello.f ./hello
331      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
332          cat 1>&2 <<EOF          cat 1>&2 <<EOF
333    
# Line 128  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 137  EOF Line 344  EOF
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 204  get_pdepend_list()  { Line 420  get_pdepend_list()  {
420      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
421          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
422          > ./.pd_tmp          > ./.pd_tmp
423      source ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
430  #  Explain usage  #  Explain usage
431  usage()  {  usage()  {
432      echo  cat <<EOF
433      echo "Usage: "$0" [OPTIONS]"  
434      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
435      echo    where [OPTIONS] can be:
436      echo "    -help | --help | -h | --h"  
437      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
438      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
439      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
440      echo "    -pdepend NAME | --pdepend NAME"      -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441      echo "      -pdepend=NAME | --pdepend=NAME"        -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442      echo "    -pdefault NAME | --pdefault NAME"            Use "NAME" as the adoptfile.  By default, the file at
443      echo "      -pdefault=NAME | --pdefault=NAME"            "tools/adjoint_options/adjoint_default" will be used.
444      echo "    -make NAME | -m NAME"  
445      echo "      --make=NAME | -m=NAME"      -nooptfile | --nooptfile
446      echo "    -makefile NAME | -mf NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447      echo "      --makefile=NAME | -mf=NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
448      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"            Use "NAME" as the optfile.  By default, an attempt will be
449      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            made to find an appropriate "standard" optfile in the
450      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"            tools/build_options/ directory.
451      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"  
452      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"      -pdepend NAME | --pdepend NAME
453      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"        -pdepend=NAME | --pdepend=NAME
454      echo "    -disable NAME | --disable NAME"            Get package dependency information from "NAME".
455      echo "      -disable=NAME | --disable=NAME"  
456      echo "    -enable NAME | --enable NAME"      -pdefault NAME | --pdefault NAME
457      echo "      -enable=NAME | --enable=NAME"        -pdefault=NAME | --pdefault=NAME
458      echo "    -standarddirs NAME | --standarddirs NAME"            Get the default package list from "NAME".
459      echo "      -standarddirs=NAME | --standarddirs=NAME"  
460      echo "    -noopt NAME | --noopt NAME"      -make NAME | -m NAME
461      echo "      -noopt=NAME | --noopt=NAME"        --make=NAME | -m=NAME
462  #    echo "    -cpp NAME | --cpp NAME"            Use "NAME" for the MAKE program. The default is "make" but
463  #    echo "      -cpp=NAME | --cpp=NAME"            many platforms, "gmake" is the preferred choice.
464      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"  
465      echo "      -fc=NAME | --fc=NAME"      -makefile NAME | -mf NAME
466      echo "    -[no]ieee | --[no]ieee"        --makefile=NAME | -mf=NAME
467      echo "    -[no]mpi | --[no]mpi"            Call the makefile "NAME".  The default is "Makefile".
468      echo "    -[no]jam | --[no]jam"  
469      echo      -makedepend NAME | -md NAME
470      echo "  and NAME is a string such as:"        --makedepend=NAME | -md=NAME
471      echo            Use "NAME" for the MAKEDEPEND program.
472      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"  
473      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475      echo            Specify the location of the MITgcm ROOTDIR as "NAME".
476      echo "  which, depending upon your shell, may need to be single-quoted"            By default, genamke will try to find the location by
477      echo "  if it contains spaces, dashes, or other special characters."            looking in parent directories (up to the 5th parent).
478    
479        -mods NAME | --mods NAME | -mo NAME | --mo NAME
480          -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
481              Here, "NAME" specifies a list of directories that are
482              used for additional source code.  Files found in the
483              "mods list" are given preference over files of the same
484              name found elsewhere.
485    
486        -disable NAME | --disable NAME
487          -disable=NAME | --disable=NAME
488              Here "NAME" specifies a list of packages that we don't
489              want to use.  If this violates package dependencies,
490              genamke will exit with an error message.
491    
492        -enable NAME | --enable NAME
493          -enable=NAME | --enable=NAME
494              Here "NAME" specifies a list of packages that we wish
495              to specifically enable.  If this violates package
496              dependencies, genamke will exit with an error message.
497    
498        -standarddirs NAME | --standarddirs NAME
499          -standarddirs=NAME | --standarddirs=NAME
500              Here, "NAME" specifies a list of directories to be
501              used as the "standard" code.
502    
503        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
504          -fc=NAME | --fc=NAME
505              Use "NAME" as the fortran compiler.  By default, genmake
506              will search for a working compiler by trying a list of
507              "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514        -[no]ieee | --[no]ieee
515              Do or don't use IEEE numerics.  Note that this option
516              *only* works if it is supported by the OPTFILE that
517              is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529      While it is most often a single word, the "NAME" variables specified
530      above can in many cases be a space-delimited string such as:
531    
532        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
533        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
534        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
535    
536      which, depending upon your shell, may need to be single-quoted.
537    
538      For more detailed genmake documentation, please see:
539    
540        http://mitgcm.org/devel_HOWTO/
541    
542    EOF
543    
544      exit 1      exit 1
545  }  }
546    
547  #eh3 # This is the generic configuration.  #  Build a CPP macro to automate calling C routines from FORTRAN
548  #eh3 set LN         = ( 'ln -s' )  get_fortran_c_namemangling()  {
549  #eh3 set CPP        = ( '/lib/cpp -P' )  
550  #eh3 set S64        = ( '$(TOOLSDIR)/set64bitConst.sh' )      #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551  #eh3 set KPP        = (  )      if test ! "x$FC_NAMEMANGLE" = x ; then
552  #eh3 set FC         = ( 'f77' )          return 0
553  #eh3 set LINK       = $FC      fi
554  #eh3 set MAKEDEPEND = ( 'makedepend' )  
555  #eh3 set INCLUDES   = ( -I. )      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556  #eh3 set FFLAGS     = (  )      
557  #eh3 set FOPTIM     = (  )      cat > genmake_test.c <<EOF
558  #eh3 set CFLAGS     = (  )  void tcall( char * string ) { tsub( string ); }
559  #eh3 set KFLAGS1    = (  )  EOF
560  #eh3 set KFLAGS2    = (  )      $MAKE genmake_test.o >> genmake_warnings 2>&1
561  #eh3 set LIBS       = (  )      RETVAL=$?
562  #eh3 set KPPFILES   = (  )      if test "x$RETVAL" != x0 ; then
563  #eh3 if (! $?NOOPTFILES ) set NOOPTFILES = (  )          FC_NAMEMANGLE=$default_nm
564  #eh3 if (! $?NOOPTFLAGS ) set NOOPTFLAGS = (  )          cat <<EOF>> genmake_errors
565    
566    WARNING: C test compile fails
567    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
568    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
569    EOF
570            return 1
571        fi
572        c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573        RETVAL=$?
574        if test "x$RETVAL" != x0 ; then
575            FC_NAMEMANGLE=$default_nm
576            cat <<EOF>> genmake_warnings
577    
578    WARNING: The "nm" command failed.
579    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
580    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
581    EOF
582            return 1
583        fi
584        cat > genmake_tcomp.f <<EOF
585          subroutine tcall( string )
586          character*(*) string
587          call tsub( string )
588          end
589    EOF
590        $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1
591        RETVAL=$?
592        if test "x$RETVAL" != x0 ; then
593            FC_NAMEMANGLE=$default_nm
594            cat <<EOF>> genmake_warnings
595    
596    WARNING: FORTRAN test compile fails -- please see "genmake_errors"
597    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
598    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
599    EOF
600            return 1
601        fi
602        f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603        RETVAL=$?
604        if test "x$RETVAL" != x0 ; then
605            FC_NAMEMANGLE=$default_nm
606            cat <<EOF>> genmake_warnings
607    
608    WARNING: The "nm" command failed.
609    WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
610    WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
611    EOF
612            return 1
613        fi
614    
615        c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
616        f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
617        c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
618        f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
619    
620        nmangle="X"
621        if test "x$c_a" != "x$f_a" ; then
622            comm="echo x$f_a | sed -e 's|x$c_a||'"
623            a=`eval $comm`
624            nmangle="$a ## $nmangle"
625        fi
626        if test "x$c_b" != "x$f_b" ; then
627            comm="echo x$f_b | sed -e 's|x$c_b||'"
628            b=`eval $comm`
629            nmangle="$nmangle ## $b"
630        fi
631    
632        FC_NAMEMANGLE="#define FC_NAMEMANGLE(X)  $nmangle"
633    
634        #  cleanup the testing files
635        rm -f genmake_tcomp.* genmake_test.*
636    }
637    
638    
639    check_HAVE_CLOC()  {
640        get_fortran_c_namemangling
641        cat <<EOF > genmake_tc_1.c
642    $FC_NAMEMANGLE
643    #include <stdio.h>
644    #include <stdlib.h>
645    #include <unistd.h>
646    #include <assert.h>
647    #include <sys/time.h>
648    void FC_NAMEMANGLE(cloc) ( double *curtim )
649    {
650     struct timeval tv1;
651     gettimeofday(&tv1 , (void *)NULL );
652     *curtim =  (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
653     *curtim = *curtim/1.E6;
654    }
655    EOF
656        make genmake_tc_1.o >> genmake_tc.log 2>&1
657        RET_C=$?
658        cat <<EOF > genmake_tc_2.f
659          program hello
660          Real*8 wtime
661          external cloc
662          call cloc(wtime)
663          print *," HELLO WORLD", wtime
664          end program hello
665    EOF
666        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
667        RET_F=$?
668        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
669        RETVAL=$?
670        if test "x$RETVAL" = x0 ; then
671            HAVE_CLOC=t
672            DEFINES="$DEFINES -DHAVE_CLOC"
673        fi
674        rm -f genmake_tc*
675    }
676    
677    
678    check_HAVE_STAT()  {
679        get_fortran_c_namemangling
680        cat <<EOF > genmake_tc_1.c
681    $FC_NAMEMANGLE
682    #include <stdio.h>
683    #include <stdlib.h>
684    #include <unistd.h>
685    #include <sys/stat.h>
686    #include <sys/types.h>
687    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
688    {
689        char name[512];
690        struct stat astat;
691    
692        name[0] = 'a'; name[1] = '\0';
693        if (! stat(name, &astat))
694            *nbyte = (int)(astat.st_size);
695        else
696            *nbyte = -1;
697    }
698    EOF
699        make genmake_tc_1.o >> genmake_tc.log 2>&1
700        RET_C=$?
701        cat <<EOF > genmake_tc_2.f
702          program hello
703          integer nbyte
704          call tfsize(nbyte)
705          print *," HELLO WORLD", nbyte
706          end program hello
707    EOF
708        $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1
709        RET_F=$?
710        test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1
711        RETVAL=$?
712        if test "x$RETVAL" = x0 ; then
713            HAVE_STAT=t
714            DEFINES="$DEFINES -DHAVE_STAT"
715        fi
716        rm -f genmake_tc*
717    }
718    
719    
720    check_netcdf_libs()  {
721        if test ! "x$SKIP_NETCDF_CHECK" = x ; then
722            return
723        fi
724        echo "" > genmake_tnc.log
725        cat <<EOF > genmake_tnc.for
726          program fgennc
727    #include "netcdf.inc"
728    EOF
729        if test ! "x$MPI" = x ; then
730            echo '#include "mpif.h"' >> genmake_tnc.for
731        fi
732        cat <<EOF >> genmake_tnc.for
733          integer iret, ncid, xid
734          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
735          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
736          iret = nf_def_dim(ncid, 'X', 11, xid)
737          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
738          iret = nf_close(ncid)
739          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
740          end
741    EOF
742        echo "Executing:" > genmake_tnc.log
743        echo "  $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f" \
744            > genmake_tnc.log
745        RET_CPP=f
746        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
747            &&  RET_CPP=t
748        if test "x$RET_CPP" = xf ; then
749            echo "  WARNING: CPP failed to pre-process the netcdf test." \
750                > genmake_tnc.log
751            echo "    Please check that \$INCLUDES is properly set." \
752                > genmake_tnc.log
753        fi
754        echo "Executing:" > genmake_tnc.log
755        echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.f" > genmake_tnc.log
756        echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log
757        $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
758            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
759        RET_COMPILE=$?
760    
761        #EH3  Remove test program execution for machines that either disallow
762        #EH3  execution or cannot support it (eg. cross-compilers)
763        #EH3
764        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
765        #EH3 RETVAL=$?
766        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
767    
768        if test "x$RET_COMPILE" = x0 ; then
769            HAVE_NETCDF=t
770        else
771            # try again with "-lnetcdf" added to the libs
772            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
773                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \
774                &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
775            RET_COMPILE=$?
776            if test "x$RET_COMPILE" = x0 ; then
777                LIBS="$LIBS -lnetcdf"
778                HAVE_NETCDF=t
779            else
780                cat genmake_tnc.log >> genmake_warnings
781            fi
782        fi
783        rm -f genmake_tnc*
784    }
785    
786    
787    
788    ###############################################################################
789    #   Sequential part of script starts here
790    ###############################################################################
791    
792  #  Set defaults here  #  Set defaults here
793  COMMANDL="$0 $@"  COMMANDL="$0 $@"
# Line 288  PLATFORM= Line 796  PLATFORM=
796  LN=  LN=
797  S64=  S64=
798  KPP=  KPP=
799  FC=  #FC=
800    #CC=gcc
801    #CPP=
802  LINK=  LINK=
803  DEFINES="-DWORDLENGTH=4"  DEFINES=
804  PACKAGES=  PACKAGES=
805  ENABLE=  ENABLE=
806  DISABLE=  DISABLE=
807  MAKEFILE=  MAKEFILE=
808  MAKEDEPEND=  #MAKEDEPEND=
809  PDEPEND=  PDEPEND=
810  DUMPSTATE=t  DUMPSTATE=t
811  PDEFAULT=  PDEFAULT=
812  OPTFILE=  OPTFILE=
813  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
814  FFLAGS=  FFLAGS=
815  FOPTIM=  FOPTIM=
816  CFLAGS=  CFLAGS=
817  KFLAGS1=  KFLAGS1=
818  KFLAGS2=  KFLAGS2=
819    #LDADD=
820  LIBS=  LIBS=
821  KPPFILES=  KPPFILES=
822  NOOPTFILES=  NOOPTFILES=
823  NOOPTFLAGS=  NOOPTFLAGS=
824    MPI=
825    MPIPATH=
826    
827    # DEFINES checked by test compilation
828    HAVE_SYSTEM=
829    HAVE_FDATE=
830    FC_NAMEMANGLE=
831    HAVE_CLOC=
832    HAVE_STAT=
833    HAVE_NETCDF=
834    HAVE_ETIME=
835    
836  MODS=  MODS=
837  TOOLSDIR=  TOOLSDIR=
838  SOURCEDIRS=  SOURCEDIRS=
839  INCLUDEDIRS=  INCLUDEDIRS=
840  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
841    
842    G2ARGS=
843    BASH=
844  PWD=`pwd`  PWD=`pwd`
845  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
846  AWK=awk  test "x$AWK" = x   &&  AWK=awk
847  THISHOSTNAME=`hostname`  THISHOST=`hostname`
848  THISCWD=`pwd`  THISCWD=`pwd`
849  THISDATE=`date`  THISDATE=`date`
850    THISUSER=`echo $USER`
851    THISVER=
852  MACHINE=`uname -a`  MACHINE=`uname -a`
853  EXECUTABLE=  EXECUTABLE=
854  EXEHOOK=  EXEHOOK=
# Line 332  IEEE= Line 858  IEEE=
858  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
859      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
860  fi  fi
861    FS=
862    FS90=
863    
864  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
865  AD_OPTFILE=  AD_OPTFILE=
# Line 348  TAMC_EXTRA= Line 876  TAMC_EXTRA=
876    
877    
878  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
879  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
880  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
881    
882  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
883  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
884  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
885  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
886  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
887    gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
888    
889  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
890  gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
891  gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"  gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
892  gm_s9="TAF_EXTRA TAMC_EXTRA"  gm_s12="TAF_EXTRA TAMC_EXTRA"
893    
894  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8 $gm_s9"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
895    gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
896    
897    cat <<EOF
898    
899    GENMAKE :
900    
901    A program for GENerating MAKEfiles for the MITgcm project.  For a
902    quick list of options, use "genmake -h" or for more detail see:
903    
904      http://mitgcm.org/devel_HOWTO/
905    
906    EOF
907    
 echo  
908  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
909  gm_local="genmake_local"  gm_local="genmake_local"
910  for i in . $MODS ; do  for i in . $MODS ; do
911      if test -r $i/$gm_local ; then      if test -r $i/$gm_local ; then
912          source $i/$gm_local          . $i/$gm_local
913          break          break
914      fi      fi
915  done  done
916  echo -n "  getting local config information:  "  printf "  getting local config information:  "
917  if test -e $gm_local ; then  if test -f $gm_local ; then
918      echo "using $gm_local"      echo "using $gm_local"
919      source $gm_local      . $gm_local
920      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
921      # echo "ENABLE=$ENABLE"      # echo "ENABLE=$ENABLE"
922  else  else
923      echo "none found"      echo "none found"
924  fi  fi
925    
926  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
927  #OPTIONS=  #OPTIONS=
928  #n=0  #n=0
929  #for i ; do  #for i ; do
# Line 396  fi Line 935  fi
935  #done  #done
936  #parse_options  #parse_options
937  ac_prev=  ac_prev=
938  for ac_option ; do  for ac_option in "$@" ; do
939    
940        G2ARGS="$G2ARGS \"$ac_option\""
941    
942      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
943      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 419  for ac_option ; do Line 960  for ac_option ; do
960          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
961              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
962                    
963          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
964              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
965          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
966              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 439  for ac_option ; do Line 980  for ac_option ; do
980          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
981              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
982                    
983            -bash | --bash)
984                ac_prev=BASH ;;
985            -bash=* | --bash=*)
986                BASH=$ac_optarg ;;
987            
988            -makedepend | --makedepend | -md | --md)
989                ac_prev=MAKEDEPEND ;;
990            -makedepend=* | --makedepend=* | -md=* | --md=*)
991                MAKEDEPEND=$ac_optarg ;;
992            
993          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
994              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
995          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
996              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
997                    
998          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
999              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
1000          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
1001              PLATFORM=$ac_optarg ;;              echo
1002                usage
1003                ;;
1004                    
1005          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
1006              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 474  for ac_option ; do Line 1027  for ac_option ; do
1027          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
1028              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
1029    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
1030  #           -cpp | --cpp)  #           -cpp | --cpp)
1031  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1032  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1033  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1034                        
1035            -cc | --cc)
1036                ac_prev=CC ;;
1037            -cc=* | --cc=*)
1038                CC=$ac_optarg ;;
1039            
1040          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1041              ac_prev=FC ;;              ac_prev=FC ;;
1042          -fc=* | --fc=*)          -fc=* | --fc=*)
1043              FC=$ac_optarg ;;              FC=$ac_optarg ;;
1044                    
1045            -fs | --fs)
1046                ac_prev=FS ;;
1047            -fs=* | --fs=*)
1048                FS=$ac_optarg ;;
1049            
1050            -fs90 | --fs90)
1051                ac_prev=FS90 ;;
1052            -fs90=* | --fs90=*)
1053                FS90=$ac_optarg ;;
1054            
1055          -ieee | --ieee)          -ieee | --ieee)
1056              IEEE=true ;;              IEEE=true ;;
1057          -noieee | --noieee)          -noieee | --noieee)
1058              IEEE= ;;              IEEE= ;;
1059            
1060          -mpi | --mpi)          -mpi | --mpi)
1061              MPI=true ;;              MPI=true ;;
1062          -nompi | --nompi)          -mpi=* | --mpi=*)
1063              MPI= ;;              MPIPATH=$ac_optarg
1064                MPI=true ;;
1065                    
1066          -jam | --jam)  #       -jam | --jam)
1067              JAM=1 ;;  #           JAM=1 ;;
1068          -nojam | --nojam)  #       -nojam | --nojam)
1069              JAM=0 ;;  #           JAM=0 ;;
1070                    
1071          -ds | --ds)          -ds | --ds)
1072              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 543  if test -f ./.genmakerc ; then Line 1107  if test -f ./.genmakerc ; then
1107      echo      echo
1108  fi  fi
1109    
1110    #  Find the MITgcm ${ROOTDIR}
1111  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1112      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1113        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1114          ROOTDIR=".."          ROOTDIR=".."
1115      else      else
1116          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1117              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1118                  ROOTDIR=$d                  ROOTDIR=$d
1119                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1120                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1121                  break                  break
1122              fi              fi
# Line 568  if test ! -d ${ROOTDIR} ; then Line 1134  if test ! -d ${ROOTDIR} ; then
1134      exit 1      exit 1
1135  fi  fi
1136    
1137    #  Find the MITgcm ${THISVER}
1138    if test -f "${ROOTDIR}/doc/tag-index" ; then
1139        THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`
1140    fi
1141    
1142  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1143  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1144      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 581  fi Line 1152  fi
1152  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
1153      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then      if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1154          echo "    using OPTFILE=\"$OPTFILE\""          echo "    using OPTFILE=\"$OPTFILE\""
1155          source "$OPTFILE"          . "$OPTFILE"
1156          RETVAL=$?          RETVAL=$?
1157          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1158              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1159              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1160              exit 1              exit 1
1161          fi          fi
# Line 597  if test "x$OPTFILE" != xNONE ; then Line 1168  if test "x$OPTFILE" != xNONE ; then
1168      fi      fi
1169  fi  fi
1170    
1171    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1172    # check_for_broken_Ff
1173    
1174  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1175  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1176      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 608  fi Line 1182  fi
1182  if test "x${AD_OPTFILE}" != xNONE ; then  if test "x${AD_OPTFILE}" != xNONE ; then
1183      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then      if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1184          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""          echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
1185          source "$AD_OPTFILE"          . "$AD_OPTFILE"
1186          RETVAL=$?          RETVAL=$?
1187          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1188              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1189              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1190              exit 1              exit 1
1191          fi          fi
# Line 624  if test "x${AD_OPTFILE}" != xNONE ; then Line 1198  if test "x${AD_OPTFILE}" != xNONE ; then
1198      fi      fi
1199  fi  fi
1200    
1201  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1202  #  and abort!  #  either set defaults or complain and abort!
1203    if test ! "x$BASH" = x ; then
1204        # add a trailing space so that it works within the Makefile syntax (see below)
1205        BASH="$BASH "
1206    fi
1207  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1208      cat <<EOF 1>&2      cat <<EOF 1>&2
1209    
# Line 636  Error: no Fortran compiler: please speci Line 1214  Error: no Fortran compiler: please speci
1214  EOF  EOF
1215      exit 1      exit 1
1216  fi  fi
1217    if test "x$CC" = x ; then
1218        CC=cc
1219    #     cat <<EOF 1>&2
1220    # Error: no C compiler: please specify using one of the following:
1221    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1222    #   2) the "-cc=XXX" command-line option
1223    #   3) the "./genmake_local" file
1224    # EOF
1225    #     exit 1
1226    fi
1227  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1228      LINK=$FC      LINK=$FC
1229  fi  fi
1230    if test "x$MAKE" = x ; then
1231        MAKE="make"
1232    fi
1233  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
1234      CPP="cpp"      CPP=cpp
1235  fi  fi
1236    #EH3 === UGLY ===
1237    #  The following is an ugly little hack to check for $CPP in /lib/ and
1238    #  it should eventually be replaced with a more general function that
1239    #  searches a combo of the user's path and a list of "usual suspects"
1240    #  to find the correct location for binaries such as $CPP.
1241    for i in " " "/lib/" ; do
1242        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1243    done
1244    #EH3 === UGLY ===
1245  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1246  RETVAL=$?  RETVAL=$?
1247  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 651  Error: C pre-processor "$CPP" failed the Line 1251  Error: C pre-processor "$CPP" failed the
1251    
1252    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"    1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1253    2) the "./genmake_local" file    2) the "./genmake_local" file
1254      3) with the CPP environment variable
1255    
1256  EOF  EOF
1257      exit 1      exit 1
1258  else  else
1259      rm -f test_cpp      rm -f test_cpp
1260  fi  fi
1261  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
1262      MAKEDEPEND=makedepend  if test "x$LN" = x ; then
1263        LN="ln -s"
1264    fi
1265    echo "test" > genmake_test_ln
1266    $LN genmake_test_ln genmake_tlink
1267    RETVAL=$?
1268    if test "x$RETVAL" != x0 ; then
1269        cat <<EOF 1>&2
1270    
1271    Error: The command "ln -s" failed -- please specify a working soft-link
1272      command in the optfile.
1273    
1274    EOF
1275        exit 1
1276    fi
1277    rm -f genmake_test_ln genmake_tlink
1278    
1279    #  Check for broken *.F/*.f handling and fix if possible
1280    check_for_broken_Ff
1281    
1282    if test ! "x$MPI" = x ; then
1283          echo "  Turning on MPI cpp macros"
1284          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1285    fi
1286    
1287    printf "\n===  Checking system libraries  ===\n"
1288    printf "  Do we have the system() command using $FC...  "
1289    cat > genmake_tcomp.f <<EOF
1290          program hello
1291          call system('echo hi')
1292          end
1293    EOF
1294    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1295    RETVAL=$?
1296    if test "x$RETVAL" = x0 ; then
1297        HAVE_SYSTEM=t
1298        DEFINES="$DEFINES -DHAVE_SYSTEM"
1299        echo "yes"
1300    else
1301        HAVE_SYSTEM=
1302        echo "no"
1303    fi
1304    rm -f genmake_tcomp*
1305    
1306    printf "  Do we have the fdate() command using $FC...  "
1307    cat > genmake_tcomp.f <<EOF
1308          program hello
1309          CHARACTER(128) string
1310          string = ' '
1311          call fdate( string )
1312          print *, string
1313          end
1314    EOF
1315    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1316    RETVAL=$?
1317    if test "x$RETVAL" = x0 ; then
1318        HAVE_FDATE=t
1319        DEFINES="$DEFINES -DHAVE_FDATE"
1320        echo "yes"
1321    else
1322        HAVE_FDATE=
1323        echo "no"
1324    fi
1325    rm -f genmake_tcomp*
1326    
1327    printf "  Do we have the etime() command using $FC...  "
1328    cat > genmake_tcomp.f <<EOF
1329          program hello
1330          REAL*4 ACTUAL, TARRAY(2)
1331          EXTERNAL ETIME
1332          REAL*4 ETIME
1333          actual = etime( tarray )
1334          print *, tarray
1335          end
1336    EOF
1337    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1338    RETVAL=$?
1339    if test "x$RETVAL" = x0 ; then
1340        HAVE_ETIME=t
1341        DEFINES="$DEFINES -DHAVE_ETIME"
1342        echo "yes"
1343    else
1344        HAVE_ETIME=
1345        echo "no"
1346    fi
1347    rm -f genmake_tcomp*
1348    
1349    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1350    check_HAVE_CLOC
1351    if test "x$HAVE_CLOC" != x ; then
1352        echo "yes"
1353    else
1354        echo "no"
1355    fi
1356    rm -f genmake_t*
1357    
1358    printf "  Can we use stat() through C calls...  "
1359    check_HAVE_STAT
1360    if test "x$HAVE_STAT" != x ; then
1361        echo "yes"
1362    else
1363        echo "no"
1364    fi
1365    rm -f genmake_t*
1366    
1367    printf "  Can we create NetCDF-enabled binaries...  "
1368    check_netcdf_libs
1369    if test "x$HAVE_NETCDF" != x ; then
1370        echo "yes"
1371    else
1372        echo "no"
1373  fi  fi
1374    
1375    
1376  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1377  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1378  for d in $MODS ; do  for d in $MODS ; do
1379      if test ! -d $d ; then      if test ! -d $d ; then
1380          echo          echo
1381          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1382          exit 1          exit 1
1383      else      else
1384          echo -n " $d"          printf " $d"
1385          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1386          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1387      fi      fi
# Line 684  if test "x${PLATFORM}" = x ; then Line 1396  if test "x${PLATFORM}" = x ; then
1396  fi  fi
1397    
1398  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1399      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1400        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1401          EXEDIR=../exe          EXEDIR=../exe
1402      else      else
1403          EXEDIR=.          EXEDIR=.
# Line 699  if test "x${TOOLSDIR}" = x ; then Line 1412  if test "x${TOOLSDIR}" = x ; then
1412      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1413  fi  fi
1414  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1415      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1416      exit 1      exit 1
1417  fi  fi
1418  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1419      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1420        RETVAL=$?
1421        if test "x${RETVAL}" = x0 ; then
1422            S64='$(TOOLSDIR)/set64bitConst.sh'
1423        else
1424            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1425            RETVAL=$?
1426            if test "x${RETVAL}" = x0 ; then
1427                S64='$(TOOLSDIR)/set64bitConst.csh'
1428            else
1429                cat <<EOF
1430    
1431    ERROR: neither of the two default scripts:
1432    
1433        ${TOOLSDIR}/set64bitConst.sh
1434        ${TOOLSDIR}/set64bitConst.csh
1435    
1436      are working so please check paths or specify (with \$S64) a
1437      working version of this script.
1438    
1439    EOF
1440                exit 1
1441            fi
1442        fi
1443  fi  fi
1444    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1445    
1446  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1447    
# Line 713  EXECUTABLE=${EXECUTABLE:-mitgcmuv} Line 1450  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1450  #  they appear as regular source code  #  they appear as regular source code
1451  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then  if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1452      echo "  Making source files in eesupp from templates"      echo "  Making source files in eesupp from templates"
1453      $MAKE -C $ROOTDIR"/eesupp/src/" > make_eesupp.errors 2>&1      ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1454      RETVAL=$?      RETVAL=$?
1455      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
1456          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1457      else      else
1458          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1459          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1460          exit 1          exit 1
1461      fi      fi
1462  fi  fi
1463    
1464    #same for exch2
1465    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1466        echo "  Making source files in exch2 from  templates"
1467        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1468        RETVAL=$?
1469        if test "x${RETVAL}" = x0 ; then
1470            rm -f make_exch2.errors
1471        else
1472            echo "Error: problem encountered while building source files in exch2:"
1473            cat make_exch2.errors 1>&2
1474            exit 1
1475        fi
1476    fi
1477    
1478  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1479  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1480      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 750  if test ! "x${RETVAL}" = x0 ; then Line 1501  if test ! "x${RETVAL}" = x0 ; then
1501      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""      echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1502      exit 1      exit 1
1503  fi  fi
1504  source ./.pd_tmp  . ./.pd_tmp
1505  rm -f ./.pd_tmp  rm -f ./.pd_tmp
1506    
1507  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1508  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1509  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1510  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1511  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1512      for i in "." $MODS ; do      for i in "." $MODS ; do
1513          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 769  if test "x${PDEFAULT}" = x ; then Line 1520  if test "x${PDEFAULT}" = x ; then
1520      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1521  fi  fi
1522  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1523      echo "default packages file disabled"      echo "    default packages file disabled"
1524  else  else
1525      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1526          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1527      else      else
1528          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1529          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1530          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1531          RETVAL=$?          RETVAL=$?
1532          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1533              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1534              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1535              exit 1              exit 1
1536          fi          fi
# Line 788  else Line 1538  else
1538              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1539          done          done
1540          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1541          expand_pkg_groups          RET=1
1542            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1543          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1544      fi      fi
1545  fi  fi
1546    
1547  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1548    for i in $PACKAGES ; do
1549        echo $i >> ./.tmp_pack
1550    done
1551    for i in `grep  "-" ./.tmp_pack` ; do
1552        j=`echo $i | sed 's/[-]//'`
1553        DISABLE="$DISABLE $j"
1554    done
1555  pack=  pack=
1556  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1557      addit="t"      addit="t"
# Line 810  PACKAGES="$pack" Line 1568  PACKAGES="$pack"
1568  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1569  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1570  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1571    # Test if each explicitly referenced package exists
1572  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1573      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1574        if test ! -d "$ROOTDIR/pkg/$j" ; then
1575          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1576          exit 1          exit 1
1577      fi      fi
1578      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1579  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1580  PACKAGES=  PACKAGES=
1581  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1582      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1583  done  done
1584    rm -f ./.tmp_pack
1585  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1586    
1587    #  Check availability of NetCDF and then either build the MNC template
1588    #  files or delete mnc from the list of available packages.
1589    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1590    RETVAL=$?
1591    if test "x$RETVAL" = x0 ; then
1592        if test "x$HAVE_NETCDF" != xt ; then
1593            cat <<EOF
1594    
1595    *********************************************************************
1596    WARNING: the "mnc" package was enabled but tests failed to compile
1597      NetCDF applications.  Please check that:
1598    
1599      1) NetCDF is correctly installed for this compiler and
1600      2) the LIBS variable (within the "optfile") specifies the correct
1601           NetCDF library to link against.
1602    
1603      Due to this failure, the "mnc" package is now DISABLED.
1604    *********************************************************************
1605    
1606    EOF
1607            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1608            DISABLE="$DISABLE mnc"
1609        else
1610            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1611            RETVAL=$?
1612            if test "x${RETVAL}" = x0 ; then
1613                rm -f make_mnc.errors
1614            else
1615                echo "Error: problem encountered while building source files in pkg/mnc:"
1616                cat make_mnc.errors 1>&2
1617                exit 1
1618            fi
1619        fi
1620    fi
1621    
1622  echo "  applying package dependency rules"  echo "  applying package dependency rules"
1623  ck=  ck=
1624  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
# Line 889  while test "x$ck" != xtt ; do Line 1683  while test "x$ck" != xtt ; do
1683              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1684              exit 1              exit 1
1685          fi          fi
1686          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1687            #i=$(( $i + 1 ))
1688      done      done
1689      ck=$ck"t"      ck=$ck"t"
1690  done  done
# Line 908  for i in $PACKAGES ; do Line 1703  for i in $PACKAGES ; do
1703      fi      fi
1704  done  done
1705    
 #  This is compatible with the old genmake.  The "DISABLE_*" flags  
 #  need to be replaced by the "ALLOW_*" flags set below.  
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
   
1706  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1707  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
   
 C  Packages disabled by genmake:  
 EOF  
1708  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1709  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1710  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1711  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1712  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1713  all_pack=  all_pack=
1714    DISABLED_PACKAGES=
1715  for n in $names ; do  for n in $names ; do
1716      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1717          has_pack="f"          has_pack="f"
# Line 957  for n in $names ; do Line 1722  for n in $names ; do
1722              fi              fi
1723          done          done
1724          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1725              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
1726              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
1727          fi          fi
1728      fi      fi
1729  done  done
1730  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1731  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1732      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
1733      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1734  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1735    
1736  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1737      case $i in      case $i in
1738          aim_v23)          aim_v23)
1739              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1740              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1741              ;;              ;;
1742      esac      esac
1743  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1744    
1745  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1746    
1747  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1748  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1749  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1750      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1751  fi  fi
1752  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1753      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1754      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1755          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1756          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1757          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1758      else              exit 1
1759          SOURCEDIRS="$SOURCEDIRS $adr"          else
1760      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1761      adr="$ROOTDIR/$d/inc"          fi
1762      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1763          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1764          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1765          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1766      else              exit 1
1767          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1768      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1769  done          fi
1770        done
1771    fi
1772    
1773  echo " Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1774  echo " of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1775  CPP_OPTIONS=  CPP_OPTIONS=
1776    CPP_EEOPTIONS=
1777  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1778    names=`ls -1 "$ROOTDIR/pkg"`
1779  for i in $spaths ; do  for i in $spaths ; do
1780      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1781      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1782          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1783          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1784          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1785            for n in $names ; do
1786                test_for_package_in_cpp_options $CPP_OPTIONS $n
1787            done
1788        fi
1789        try="$i/CPP_EEOPTIONS.h"
1790        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1791            echo "    found CPP_EEOPTIONS=\"$try\""
1792            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1793    #**** not yet enabled ****
1794    #        test_for_mpi_in_cpp_eeoptions $try
1795    #**** not yet enabled ****
1796            CPP_EEOPTIONS="$try"
1797      fi      fi
1798  done  done
1799  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1800      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1801      exit 1      exit 1
1802  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1803    
1804  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1805  #  compiler.  #  compiler.
# Line 1077  for i in $SOURCEDIRS ; do Line 1814  for i in $SOURCEDIRS ; do
1814      done      done
1815  done  done
1816    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1817    
1818  echo  echo
1819  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1820  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1821  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1822      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1823          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1824      fi      fi
1825  done  done
# Line 1105  rm -rf .links.tmp Line 1829  rm -rf .links.tmp
1829  mkdir .links.tmp  mkdir .links.tmp
1830  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1831  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1832  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1833  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1834  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1835  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1836  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1837  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1838  for d in $alldirs ; do  for d in $alldirs ; do
1839      deplist=      deplist=
# Line 1118  for d in $alldirs ; do Line 1842  for d in $alldirs ; do
1842      for sf in $sfiles ; do      for sf in $sfiles ; do
1843          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1844              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1845                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  case $d/$sf in
1846                  touch .links.tmp/$sf                    ./$PACKAGES_DOT_H)
1847                  deplist="$deplist $sf"                          ;;
1848                      ./AD_CONFIG.h)
1849                            ;;
1850                      ./FC_NAMEMANGLE.h)
1851                            ;;
1852                      ./BUILD_INFO.h)
1853                            ;;
1854                      *)
1855                            touch .links.tmp/$sf
1856                            deplist="$deplist $sf"
1857                            ;;
1858                    esac
1859                    extn=`echo $sf | $AWK -F. '{print $NF}'`
1860                  case $extn in                  case $extn in
1861                      F)                      F)
1862                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1863                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1864                          ;;                          ;;
1865                      F90)                      F90)
1866                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1867                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1868                          ;;                          ;;
1869                      c)                      c)
1870                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1871                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1872                          ;;                          ;;
1873                      h)                      h)
1874                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1875                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1876                          ;;                          ;;
1877                      flow)                      flow)
1878                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1879                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1880                          ;;                          ;;
1881                  esac                  esac
1882              fi              fi
# Line 1160  echo "" >> f90srclist.inc Line 1896  echo "" >> f90srclist.inc
1896  echo "" >> hlist.inc  echo "" >> hlist.inc
1897  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1898    
1899  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1900      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1901  fi  fi
1902  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1169  echo "#    $MACHINE" >> $MAKEFILE Line 1905  echo "#    $MACHINE" >> $MAKEFILE
1905  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1906  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1907  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1908  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1909  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1910  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
1911    
1912    EXE_AD=$EXECUTABLE"_ad"
1913    EXE_FTL=$EXECUTABLE"_ftl"
1914    EXE_SVD=$EXECUTABLE"_svd"
1915    
1916  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1917    #
1918    # OPTFILE="$OPTFILE"
1919  #  #
1920  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1921  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1202  TOOLSDIR    = ${TOOLSDIR} Line 1945  TOOLSDIR    = ${TOOLSDIR}
1945    
1946  #eh3  new defines for the adjoint work  #eh3  new defines for the adjoint work
1947  AUTODIFF    = ${ROOTDIR}/pkg/autodiff  AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1948    EXE_AD      = ${EXE_AD}
1949    EXE_FTL     = ${EXE_FTL}
1950    EXE_SVD     = ${EXE_SVD}
1951    
1952    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1953    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1954    
1955    # These files are created by Makefile
1956    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
1957    
1958  EOF  EOF
1959    
# Line 1220  KPP = ${KPP} Line 1972  KPP = ${KPP}
1972  FC = ${FC}  FC = ${FC}
1973  # Fortran compiler  # Fortran compiler
1974  F90C = ${F90C}  F90C = ${F90C}
1975    # C compiler
1976    CC = ${CC}
1977  # Link editor  # Link editor
1978  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1979    
1980  # Defines for CPP  # Defines for CPP
1981  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1242  CFLAGS = ${CFLAGS} Line 1996  CFLAGS = ${CFLAGS}
1996  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
1997  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
1998  # Flags and libraries needed for linking  # Flags and libraries needed for linking
1999  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2000  # Name of the Mekfile  # Name of the Mekfile
2001  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2002    
# Line 1253  cat csrclist.inc      >> $MAKEFILE Line 2007  cat csrclist.inc      >> $MAKEFILE
2007  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
2008  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
2009  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2010  echo               >> $MAKEFILE  echo >> $MAKEFILE
2011  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2012  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
2013  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2014    echo >> $MAKEFILE
2015    echo '.SUFFIXES:' >> $MAKEFILE
2016    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2017  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2018  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2019    
2020  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2021    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
2022  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2023  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
2024            @echo Creating \$@ ...
2025          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2026  depend:  depend:
2027          @make links          @make links
2028          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
2029          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2030            -rm -f makedepend.out
2031    
2032  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2033    
2034  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
2035    
# Line 1283  output.txt: \$(EXECUTABLE) Line 2038  output.txt: \$(EXECUTABLE)
2038          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2039    
2040  clean:  clean:
2041          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2042  Clean:  Clean:
2043          @make clean          @make clean
2044          @make cleanlinks          @make cleanlinks
2045          -rm -f Makefile.bak genmake_state genmake_optfile make.log          -rm -f \$(SPECIAL_FILES)
2046            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2047  CLEAN:  CLEAN:
2048          @make Clean          @make Clean
2049          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2050          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2051          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2052          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
2053    
2054  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2055  makefile:  makefile:
2056          ${0} $@          $THIS_SCRIPT $G2ARGS
2057  cleanlinks:  cleanlinks:
2058          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2059    
2060  # The normal chain of rules is (  .F - .f - .o  )  # Special targets (SPECIAL_FILES) which are create by make
2061  .F.f:  ${PACKAGES_DOT_H}:
2062            @echo Creating \$@ ...
2063            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2064    AD_CONFIG.h:
2065            @echo Creating \$@ ...
2066            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2067    FC_NAMEMANGLE.h:
2068            @echo Creating \$@ ...
2069            echo "$FC_NAMEMANGLE" > \$@
2070    
2071    BUILD_INFO.h:
2072            @echo Creating \$@ ...
2073    EOF
2074    
2075    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2076    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2077    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2078    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2079    
2080    cat >>$MAKEFILE <<EOF
2081    
2082    # The normal chain of rules is (  .F - .$FS - .o  )
2083    
2084    ## This nullifies any default implicit rules concerning these two file types:
2085    ## %.o : %.F
2086    
2087    .F.$FS:
2088          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2089  .f.o:  .$FS.o:
2090          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2091  .F90.f90:  .F90.$FS90:
2092          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2093  .f90.o:  .$FS90.o:
2094          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2095  .c.o:  .c.o:
2096          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
2097    
2098  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2099  .F.p:  .F.p:
2100          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2101  .p.f:  .p.$FS:
2102          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2103    
2104  #=========================================  #=========================================
# Line 1343  done Line 2125  done
2125    
2126  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
2127  echo >> $MAKEFILE  echo >> $MAKEFILE
2128  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2129  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2130  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2131      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2132      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2133  done  done
2134  echo >> $MAKEFILE  echo >> $MAKEFILE
2135    rm -f ad_files
2136    
2137  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2138    
2139  ad_input_code.f: \$(F77FILES)  # ... AD ...
2140    adall: ad_taf
2141    adtaf: ad_taf_output.f
2142    adtamc: ad_tamc_output.f
2143    
2144    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2145            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2146            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2147            -rm -f ad_config.template
2148            @make \$(F77FILES)
2149          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2150          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
2151    
 # ... AD ...  
2152  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
2153          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2154          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2155    
2156    adtafonly:
2157            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
2158            cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
2159    
2160  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
2161          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2162    
2163  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
2164          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
2165          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
2166    
2167  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2168          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2169    
2170    adonlyfwd:
2171            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2172    
2173    adtrick:
2174            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2175    
2176  # ... FLT ...  # ... FTL ...
2177  flt_taf_output.f: ad_input_code.f  ftlall: ftl_taf
2178          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f  ftltaf: ftl_taf_output.f
2179          cat ad_input_code_ad.f | sed -f adjoint_sed > flt_taf_output.f  ftltamc: ftl_tamc_output.f
2180    
2181    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2182            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2183            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2184            -rm -f ftl_config.template
2185            @make \$(F77FILES)
2186            @make \$(AD_FLOW_FILES)
2187            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
2188    
2189  flt_taf: flt_taf_output.o \$(OBJFILES)  ftl_taf_output.f: ftl_input_code.f
2190          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) flt_taf_output.o \$(LIBS)          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2191            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2192    
2193  flt_tamc_output.f: ad_input_code.f  ftltafonly:
2194          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
2195          cat ad_input_code_ad.f | sed -f adjoint_sed > flt_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
2196    
2197  flt_tamc: flt_tamc_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2198          \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) flt_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2199    
2200    ftl_tamc_output.f: ftl_input_code.f
2201            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
2202            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
2203    
2204  # ... SVD ...  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2205  svd_taf_output.f: ad_input_code.f          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f  
         cat ad_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
2206    
 svd_taf: svd_taf_output.o \$(OBJFILES)  
         \$(LINK) -o ${EXECUTABLE} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)  
2207    
2208    # ... SVD ...
2209    svdtaf: ad_taf_output.f ftl_taf_output.f
2210            @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2211            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2212    svdall: svd_touch svd_taf
2213    
2214    svd_taf: \$(OBJFILES)
2215            \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2216    
2217            @echo "--->>> Only COMPILE svd code! <<<---"
2218            @echo "--->>> Assumes you previously <<<---"
2219            @echo "--->>> did make svdtaf        <<<---"
2220    
2221    svd_touch:
2222            @echo "--->>> Only COMPILE svd code! <<<---"
2223            @echo "--->>> Assumes you previously <<<---"
2224            @echo "--->>> did make svdtaf        <<<---"
2225            touch ad_taf_output.f ftl_taf_output.f
2226            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f
2227            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f
2228            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2229            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2230            -rm -f ftl_config.template
2231    
2232  #=========================================  #=========================================
2233    
# Line 1413  for i in $KPPFILES ; do Line 2244  for i in $KPPFILES ; do
2244      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2245          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2246      fi      fi
2247      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2248  done  done
2249    
2250  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1423  for i in $NOOPTFILES ; do Line 2254  for i in $NOOPTFILES ; do
2254      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2255          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2256      fi      fi
2257      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2258      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2259  done  done
2260    
# Line 1436  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2267  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2267    
2268  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2269    
2270    # Create special header files
2271    $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2272    if test ! -f $PACKAGES_DOT_H ; then
2273        mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2274    else
2275        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
2276        RETVAL=$?
2277        if test "x$RETVAL" = x0 ; then
2278            rm -f $PACKAGES_DOT_H".tmp"
2279        else
2280            mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
2281            mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2282        fi
2283    fi
2284    if test ! -f AD_CONFIG.h ; then
2285        $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2286    fi
2287    
2288    
2289  #  Write the "state" for future records  #  Write the "state" for future records
2290  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2291      echo -n "" > genmake_state      printf "" > genmake_state
2292      for i in $gm_state ; do      for i in $gm_state ; do
2293          t1="t2=\$$i"          t1="t2=\$$i"
2294          eval $t1          eval $t1

Legend:
Removed from v.1.18  
changed lines
  Added in v.1.116

  ViewVC Help
Powered by ViewVC 1.1.22